﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ServiceStack.Common.Utils;
using ServiceStack.Configuration;

namespace ICSV.Interface
{
	/// <summary>
	/// Web server configuration data container.
	/// </summary>
	public class EMDConfig
	{
		/// <summary>
		/// The namespace we are working in.
		/// </summary>
		public const string DefaultNamespace = "http://schemas.servicestack.net/types";

		public EMDConfig() { }

		public EMDConfig(IResourceManager appConfig)
		{
			FlickrKey = appConfig.GetString("FlickrKey");
			FlickrSecret = appConfig.GetString("FlickrSecret");
		}

		/// <summary>
		/// To use the Flickr API, we need a key.
		/// </summary>
		public string FlickrKey { get; set; }
		
		/// <summary>
		/// To use the Flickr API, we need a secret
		/// </summary>
		public string FlickrSecret { get; set; }

		/// <summary>
		/// The path on the webserver to the images directory.
		/// The images directory contains e.g. the static images of the axes.
		/// </summary>
		public string WebHostImgPath { get; set; }
	}
}
