﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using ICSV.Interface.Types;

namespace ICSV.Interface.Operations
{
    /// <summary>
    /// DTO for requesting the status of a currently ongoing search.
    /// The result will be of <see cref="GetStatusResponse"/>
    /// </summary>
    public class GetStatus
    {
        /// <summary>
        /// The search id.
        /// </summary>
        public int ForSearchId { get; set; }
    }

    /// <summary>
    /// The response to a status request
    /// </summary>
    public class GetStatusResponse
    {
        /// <summary>
        /// The search id.
        /// </summary>
        public int SearchId { get; set; }

        /// <summary>
        /// A list of status DTOs.
        /// <seealso cref="StatusData"/>
        /// </summary>
        public ArrayOfStatusData Status { get; set; }
    }
}
