﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ICSV.Interface.Types
{
	/// <summary>
	/// New data of an image or an update for an existing image. Included in the list of an <see cref="GetImageResultsResponse"/> object.
	/// </summary>
	public class ImageData
	{
		/// <summary>
		/// The unique identifier of the image.
		/// Could be NULL, in which case the object represents a FAKE result to tell the client that the server is still
		/// alive and working on a request.
		/// </summary>
		public string Id { get; set; }

		/// <summary>
		/// The URL of the image (is typically a Base64 data URI). Could be a huge string!
		/// Could be NULL, in which case this object only represents an update of positions for previously received image information.
		/// </summary>
		public string Url { get; set; }

		/// <summary>
		/// 2D coordinates where to render the image on the client's canvas.
		/// </summary>
		public ImagePosition pos2D { get; set; }

		/// <summary>
		/// 3D coordinates where to render the image on the client's canvas.
		/// </summary>
		public ImagePosition pos3D { get; set; }
	}
}
