﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ICSV.Interface.Types
{
    /// <summary>
    /// A status object, incuded in the list of a <see cref="GetStatusResponse"/>
    /// </summary>
    public class StatusData
    {
        /// <summary>
        /// Possible enumeration of types used in the 'Id' field of <see cref="StatusData"/>
        /// </summary>
        public enum Type
        {
            INFO = 0,
            //IMAGE_LOADED = 1, // not used anymore
            FINISHED = 2,
            CANCELLED = 3,
            STILL_ALIVE = 4
        }

        /// <summary>
        /// The message associated with this status object.
        /// </summary>
        public string Message { get; set; }

        /// <summary>
        /// The id, which actually represents the type.
        /// </summary>
        /// <seealso cref="Type"/>
        public int Id { get; set; }
    }
}
