﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ICSV.Server.Signatures
{
    /// <summary>
    /// See https://github.com/telmomenezes/JFastEMD/blob/master/src/com/telmomenezes/jfastemd/Feature2D.java
    /// </summary>
    /// <remarks>
    /// @author Telmo Menezes (telmo@telmomenezes.com)
    /// </remarks>
    class Feature2D : Feature
    {
        public double X { get; private set; }
        public double Y { get; private set; }

        public Feature2D(double x, double y)
        {
            this.X = x;
            this.Y = y;
        }

        public double groundDist(Feature f)
        {
            Feature2D f2d = (Feature2D)f;
            double deltaX = X - f2d.X;
            double deltaY = Y - f2d.Y;
            double distance = Math.Sqrt((deltaX * deltaX) + (deltaY * deltaY));
            
            return distance;

            //return Math.Min(distance, 200); // thresholded distance (also a metric!) see "Fast and Robust Earth Mover's Distances" by Pele & Werman
            // (thresholded distance should compute faster) WARNING threshold = 20 totally different result
        }
    }
}
