﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ICSV.Server.Signatures
{
    /// <summary>
    /// Same as <see cref="Feature2D"/> but with 3D coordinates
    /// </summary>
    class Feature3D : Feature
    {
        // (x,y,z) is typically the CIELab L,a,b

        public double X { get; private set; }
        public double Y { get; private set; }
        public double Z { get; private set; }

        public Feature3D(double x, double y, double z)
        {
            this.X = x;
            this.Y = y;
            this.Z = z;
        }

        public double groundDist(Feature f)
        {
            // calculate the Euclidean distance between the two colors in CIELab color space
            Feature3D f3d = (Feature3D)f;
            double deltaX = X - f3d.X;
            double deltaY = Y - f3d.Y;
            double deltaZ = Z - f3d.Z;
            double distance = Math.Sqrt((deltaX * deltaX) + (deltaY * deltaY) + (deltaZ * deltaZ));
            
            return distance;

            /*
             * WARNING!
             * Thresholding the distance means that the axes of the CIELab color space will be very distorted
             */ 

            //return Math.Min(distance, 50); // thresholded distance (also a metric!) see "Fast and Robust Earth Mover's Distances" by Pele & Werman
            // (thresholded distance should compute faster) WARNING threshold = 20 totally different result
        }
    }
}
